﻿Imports System.Runtime.InteropServices

Public Class FRM_CatturaPixel

    Const Dispositivo As String = "RGB_Led_Controller"

    Dim ThreadLetturaPixel As Threading.Thread
    Dim DimensioniSchermo As New Size(Screen.PrimaryScreen.Bounds.Width, Screen.PrimaryScreen.Bounds.Height)
    Dim IconaNotifiche As New NotifyIcon
    Dim DovreiChiudermiSulSerio As Boolean

    'Parametri fasce
    Dim ColonneDaSaltare As Integer = My.Settings.SaltoVerticale 'Specifica quante colonne verticali saltare per ognuna presa in considerazione: di default 10
    Dim RigheDaSaltare As Integer = My.Settings.SaltoOrizzontale 'Specifica quante righe orizzontali saltare per ognuna presa in considerazione: di default 10
    Dim DimensioniFascia As New Size(My.Settings.LarghezzaFasce, DimensioniSchermo.Height) 'Specifica la dimensione della fascia sinistra: di default (150, *AltezzaSchermo*)
    Dim InizioFasciaSinistra As New Point(0, 0) 'Specifica dove si trova l'angolo superiore sinistro della fascia sinistra: di default è (0, 0)
    Dim InizioFasciaDestra As New Point(DimensioniSchermo.Width - DimensioniFascia.Width - 1, 0) 'Specifica dove si trova l'angolo superiore sinistro della fascia destra: di default è (*LarghezzaSchermo* - *LarghezzaFasciaDestra* - 1, 0) 
    Dim OffsetSopra As Integer = My.Settings.OffsetSopra 'specifica quanti pixel ignorare in alto: di default 0
    Dim OffsetSotto As Integer = My.Settings.OffsetSotto 'specifica quanti pixel ignorare in basso: di default 0

    Dim NumeroLetture As Integer
    Dim SegnaTempo As New Stopwatch

    Dim ConnessioneOk As Boolean

    <DllImport("gdi32.dll")> Private Shared Function BitBlt(ByVal hdc As IntPtr, ByVal nXDest As Integer, ByVal nYDest As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hdcSrc As IntPtr, ByVal nXSrc As Integer, ByVal nYSrc As Integer, ByVal dwRop As CopyPixelOperation) As Boolean
    End Function
    <DllImport("user32.dll")> Private Shared Function ReleaseDC(ByVal hWnd As IntPtr, ByVal hDC As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function
    <DllImport("gdi32.dll")> Private Shared Function DeleteDC(ByVal hdc As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function
    <DllImport("gdi32.dll")> Private Shared Function DeleteObject(ByVal hObject As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function
    <DllImport("gdi32.dll")> Private Shared Function CreateCompatibleBitmap(ByVal hdc As IntPtr, ByVal nWidth As Integer, ByVal nHeight As Integer) As IntPtr
    End Function
    <DllImport("gdi32.dll", SetLastError:=True)> Private Shared Function CreateCompatibleDC(ByVal hRefDC As IntPtr) As IntPtr
    End Function
    <DllImport("gdi32.dll")> Private Shared Function SelectObject(ByVal hdc As IntPtr, ByVal hObject As IntPtr) As IntPtr
    End Function
    <DllImport("user32.dll", SetLastError:=False)> Private Shared Function GetDesktopWindow() As IntPtr
    End Function
    <DllImport("user32.dll")> Private Shared Function GetWindowDC(ByVal hWnd As IntPtr) As IntPtr
    End Function

    Private Sub FRM_CatturaPixel_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If DovreiChiudermiSulSerio Then
            If ComPort.IsOpen() Then ComPort.Close()
            If ThreadLetturaPixel IsNot Nothing Then
                If ThreadLetturaPixel.IsAlive Then ThreadLetturaPixel.Abort()
            End If
            IconaNotifiche.Visible = False
        Else
            Me.Visible = False
            e.Cancel = True
        End If
        SalvaImpostazioni()
    End Sub

    Private Sub FRM_CatturaPixel_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'imposto i valori limite dei parametri di configurazione
        NUM_larghezza.Maximum = DimensioniSchermo.Width \ 2

        NUM_saltoOrizzontale.Maximum = NUM_larghezza.Value
        NUM_saltoVerticale.Maximum = DimensioniSchermo.Height \ 2

        NUM_offsetSotto.Maximum = DimensioniSchermo.Height \ 2
        NUM_offsetSopra.Maximum = DimensioniSchermo.Height \ 2

        'Mi avvio nascosto
        Me.Visible = False
        Me.ShowInTaskbar = False

        'Carico le impostazioni
        CaricaImpostazioni()
        'Gestisco la Notify Icon
        GestisciNotifyIcon()
        'Avvio la lettura dei colori
        AvvioLettura()
    End Sub

    Sub LoopPrincipale()
        'Da eliminare dopo la fase di testing le prossime 3 righe
        SegnaTempo.Start()

        Do
            Dim ColoreMedioSinistra As Color = ColoreMedioInAreaDiPixel(InizioFasciaSinistra, DimensioniFascia, RigheDaSaltare, ColonneDaSaltare, OffsetSopra, OffsetSotto)
            Dim ColoreMedioDestra As Color = ColoreMedioInAreaDiPixel(InizioFasciaDestra, DimensioniFascia, RigheDaSaltare, ColonneDaSaltare, OffsetSopra, OffsetSotto)

            InviaDatiAlPIC(ColoreMedioSinistra, ColoreMedioDestra)

            'Da eliminare dopo la fase di testing le prossime 4 righe
            NumeroLetture += 1
            Invoke(New ScriviNellaTextboxDelegate(AddressOf ScriviNellaTextbox), ColoreMedioSinistra.ToString.Substring(6), TXT_Sinistra)
            Invoke(New ScriviNellaTextboxDelegate(AddressOf ScriviNellaTextbox), ColoreMedioDestra.ToString.Substring(6), TXT_Destra)
            Invoke(New ScriviNellaTextboxDelegate(AddressOf ScriviNellaTextbox), Math.Truncate(NumeroLetture / SegnaTempo.Elapsed.TotalSeconds).ToString, TXT_fps)
        Loop
    End Sub

    Sub GestisciNotifyIcon()
        Dim MenuContestuale As New ContextMenu
        Dim Impostazioni As New MenuItem
        Dim StartStop As New MenuItem
        Dim Informazioni As New MenuItem
        Dim Esci As New MenuItem
        IconaNotifiche.Text = "Cattura Pixel"
        IconaNotifiche.Icon = My.Resources.RGB_on
        Impostazioni.Text = "Impostazioni"
        AddHandler IconaNotifiche.Click, AddressOf ImpostazioniClick
        AddHandler Impostazioni.Click, AddressOf ImpostazioniClick
        Informazioni.Text = "Info"
        AddHandler Informazioni.Click, AddressOf InformazioniClick
        Esci.Text = "Esci"
        AddHandler Esci.Click, AddressOf EsciClick
        StartStop.Text = "Stop"
        AddHandler StartStop.Click, AddressOf StartStopClick
        MenuContestuale.MenuItems.Add(Impostazioni)
        MenuContestuale.MenuItems.Add(StartStop)
        MenuContestuale.MenuItems.Add(Informazioni)
        MenuContestuale.MenuItems.Add(Esci)

        IconaNotifiche.ContextMenu = MenuContestuale
        IconaNotifiche.Visible = True
    End Sub


    Sub ImpostazioniClick()
        Me.Location = New Point(DimensioniSchermo.Width - Me.Width - 300, DimensioniSchermo.Height - Me.Height - 75)
        Me.Visible = True
        Me.WindowState = FormWindowState.Normal
        Me.BringToFront()
    End Sub

    Sub informazioniClick()
        FRM_Info.Show()
    End Sub

    Sub EsciClick()
        SalvaImpostazioni()
        DovreiChiudermiSulSerio = True
        Me.Close()
    End Sub

    Sub StartStopClick()
        If IconaNotifiche.ContextMenu.MenuItems(1).Text = "Stop" Then
            'Fermo la lettura
            FermaLettura()
        Else
            'Avvio la lettura
            AvvioLettura()
        End If
    End Sub

    Sub CaricaImpostazioni()
        NUM_larghezza.Value = My.Settings.LarghezzaFasce
        NUM_saltoOrizzontale.Value = My.Settings.SaltoOrizzontale
        NUM_saltoVerticale.Value = My.Settings.SaltoVerticale
        NUM_offsetSopra.Value = My.Settings.OffsetSopra
        NUM_offsetSotto.Value = My.Settings.OffsetSotto
    End Sub

    Sub SalvaImpostazioni()
        My.Settings.LarghezzaFasce = NUM_larghezza.Value
        My.Settings.SaltoOrizzontale = NUM_saltoOrizzontale.Value
        My.Settings.SaltoVerticale = NUM_saltoVerticale.Value
        My.Settings.OffsetSopra = NUM_offsetSopra.Value
        My.Settings.OffsetSotto = NUM_offsetSotto.Value
        My.Settings.Save()
    End Sub

    'Da eliminare dopo la fase di testing la prossima Delegate e la prossima Sub
    Delegate Sub ScriviNellaTextboxDelegate(ByVal Testo As String, ByVal Valore As TextBox)
    Sub ScriviNellaTextbox(ByVal Testo As String, ByVal Valore As TextBox)
        Valore.Text = (Testo & vbCrLf)
    End Sub

    Function ColoreMedioInAreaDiPixel(ByVal InizioArea As Point, ByVal DimensioneArea As Size, Optional ByVal SaltaInOrizzontale As Integer = 0, Optional ByVal SaltaInVerticale As Integer = 0, Optional ByVal OffsetSopra As Integer = 0, Optional ByVal OffsetSotto As Integer = 0) As Color
        Dim Red, Green, Blue As Integer
        Dim Colore As Color
        Dim NumeroPixelAnalizzati As Integer

        Dim HandleSchermo As IntPtr = GetDesktopWindow()
        Dim HandleSorgente As IntPtr = GetWindowDC(HandleSchermo)
        Dim HandleDestinazione As IntPtr = CreateCompatibleDC(HandleSorgente)
        Dim HandleBitmap As IntPtr = CreateCompatibleBitmap(HandleSorgente, DimensioneArea.Width, DimensioneArea.Height)
        Dim HandleBitmapOld As IntPtr = SelectObject(HandleDestinazione, HandleBitmap)
        Dim CopiaFascia As Boolean = BitBlt(HandleDestinazione, 0, 0, DimensioneArea.Width, DimensioneArea.Height, HandleSorgente, InizioArea.X, InizioArea.Y, CopyPixelOperation.SourceCopy Or CopyPixelOperation.CaptureBlt)
        Dim BitmapFascia As Bitmap = Bitmap.FromHbitmap(HandleBitmap)
        SelectObject(HandleDestinazione, HandleBitmapOld)
        DeleteObject(HandleBitmap)
        DeleteDC(HandleDestinazione)
        ReleaseDC(HandleSchermo, HandleSorgente)

        For PixelY = (0 + OffsetSopra) To (DimensioneArea.Height - 1 - OffsetSotto) Step SaltaInVerticale + 1
            For PixelX = 0 To DimensioneArea.Width - 1 Step SaltaInOrizzontale + 1
                Colore = BitmapFascia.GetPixel(PixelX, PixelY)
                Red += Colore.R
                Green += Colore.G
                Blue += Colore.B
                NumeroPixelAnalizzati += 1
            Next
        Next

        Red /= NumeroPixelAnalizzati
        Green /= NumeroPixelAnalizzati
        Blue /= NumeroPixelAnalizzati

        BitmapFascia.Dispose()

        Return Color.FromArgb(Red, Green, Blue)
    End Function

    Sub InviaDatiAlPIC(ByVal ColoreSinistra As Color, ByVal ColoreDestra As Color)
        'Gestisci qui l'invio dei dati al PIC
        'Puoi ottenere i valori RGB da ColoreSinistra e ColoreDestra con:
        'ColoreSinistra.R, ColoreSinistra.G, ColoreSinistra.B e
        'ColoreDestra.R, ColoreDestra.G, ColoreDestra.B
        If ComPort.IsOpen Then
            ComPort.Write("l" & Chr(ColoreSinistra.R) & Chr(ColoreSinistra.G) & Chr(ColoreSinistra.B))
            ComPort.Write("r" & Chr(ColoreDestra.R) & Chr(ColoreDestra.G) & Chr(ColoreDestra.B))
        End If
    End Sub

    Private Sub BTN_start_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_start.Click
        AvvioLettura()
    End Sub

    Private Sub BTN_stop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_stop.Click
        FermaLettura()
    End Sub

    Private Sub BTN_info_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BTN_info.Click
        FRM_Info.ShowDialog()
    End Sub

    Sub AvvioLettura()
        AutoSearch()
        If ConnessioneOk Then
            TXT_portDebug.AppendText("Avviato" & vbCrLf)
            BTN_start.Enabled = False
            BTN_stop.Enabled = True

            ComPort.Open()
            'inizializzazione controller
            TXT_portDebug.AppendText("Accensione controller.." & vbCrLf)
            ComPort.Write("c--" & Chr(4))
            TXT_portDebug.AppendText(ComPort.ReadLine() & vbCrLf)
            TXT_portDebug.AppendText(ComPort.ReadLine() & vbCrLf)
            TXT_portDebug.AppendText("Modalità PC_MODE" & vbCrLf)
            ComPort.Write("c--" & Chr(1))
            TXT_portDebug.AppendText(ComPort.ReadLine() & vbCrLf)

            ThreadLetturaPixel = New Threading.Thread(AddressOf LoopPrincipale)
            ThreadLetturaPixel.Start()

            IconaNotifiche.Icon = My.Resources.RGB_on
            IconaNotifiche.ContextMenu.MenuItems(1).Text = "Stop"
        Else
            IconaNotifiche.Icon = My.Resources.RGB_off
            IconaNotifiche.ContextMenu.MenuItems(1).Text = "Start"
        End If
    End Sub

    Sub FermaLettura()
        BTN_start.Enabled = True
        BTN_stop.Enabled = False
        TXT_portDebug.AppendText("Stop" & vbCrLf)
        InviaDatiAlPIC(Color.Black, Color.Black)
        ComPort.Write("c--" & Chr(3))
        ComPort.Close()
        ThreadLetturaPixel.Abort()

        IconaNotifiche.Icon = My.Resources.RGB_off
        IconaNotifiche.ContextMenu.MenuItems(1).Text = "Start"
    End Sub

#Region "Parametri"

    Private Sub NUM_larghezza_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NUM_larghezza.ValueChanged
        NUM_saltoOrizzontale.Maximum = NUM_larghezza.Value
        DimensioniFascia.Width = NUM_larghezza.Value
        If NUM_larghezza.Value >= NUM_larghezza.Maximum Then

        Else


        End If
        NumeroLetture = 0
        SegnaTempo.Restart()
    End Sub

    Private Sub NUM_saltoOrizzontale_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NUM_saltoOrizzontale.ValueChanged
        ColonneDaSaltare = NUM_saltoOrizzontale.Value
        NumeroLetture = 0
        SegnaTempo.Restart()
    End Sub

    Private Sub NUM_saltoVerticale_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NUM_saltoVerticale.ValueChanged
        RigheDaSaltare = NUM_saltoVerticale.Value
        NumeroLetture = 0
        SegnaTempo.Restart()
    End Sub

    Private Sub Num_offsetSopra_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NUM_offsetSopra.ValueChanged
        OffsetSopra = NUM_offsetSopra.Value
    End Sub

    Private Sub NUM_offsetSotto_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NUM_offsetSotto.ValueChanged
        OffsetSotto = NUM_offsetSotto.Value
    End Sub

#End Region

#Region "Setup comunicazione"

    Sub AutoSearch()
        Dim i As Integer = 0

        Dim PorteDisponibili As String() = System.IO.Ports.SerialPort.GetPortNames()
        ConnessioneOk = False

        For i = 0 To PorteDisponibili.Length() - 1
            ConnessioneOk = TestPorta(PorteDisponibili(i))
            If ConnessioneOk Then
                TXT_portDebug.AppendText(ComPort.PortName() + "...OK" + vbCrLf)
                Exit For
            Else
                TXT_portDebug.AppendText(ComPort.PortName() + "...non trovato" + vbCrLf)
            End If
        Next

        If Not ConnessioneOk Then MessageBox.Show("RGB Led Controller non trovato, verificare che sia connesso ed acceso.", "Attenzione!", MessageBoxButtons.OK, MessageBoxIcon.Warning)
    End Sub

    Function TestPorta(ByVal PortName As String) As Boolean
        Dim Risposta As String = String.Empty
        Dim EsitoTest As Boolean = True

        If ComPort.IsOpen Then ComPort.Close()
        ComPort.PortName = PortName

        Try
            If Not ComPort.IsOpen Then ComPort.Open()
            ComPort.DiscardInBuffer()
            ComPort.Write("s---")
            Risposta = ComPort.ReadLine()
        Catch ex As Exception
            TXT_portDebug.AppendText(ex.Message.ToString() + vbCrLf)
            EsitoTest = False
        End Try

        If Not Risposta = String.Empty Then
            TXT_portDebug.AppendText(Risposta + vbCrLf)

            If Risposta.Length > Dispositivo.Length Then
                Risposta.Remove(Dispositivo.Length)
            End If
        End If

        If Not Risposta = Dispositivo Then
            EsitoTest = False
        End If

        ComPort.Close()

        Return EsitoTest
    End Function

#End Region



End Class
